#! /usr/local/bin/perl
# Copyright (C) 2009 OKADA Hitoshi
# Perl5
#
# ꤷCE3եλꤷ쥤䡼ʳޤ
#
#  perl layerFilter.pl  -L maskvalue CE3file[Enter]
#
# CE3fileBSch3VΥǡǤĥҤCE3ǤʤФʤޤ
#
# 쥤䡼 -L maskvalue ǻꤷޤ
# maskvalue  ΥӥåͤORΤ16ʿɽ路ޤ
#
#    쥤䡼  ӥå
# ---------------------
#   쥤䡼0   0x01
#   쥤䡼1   0x02
#      :          :
#   쥤䡼6   0x40
#   쥤䡼7   0x80
#
# ȤСsample.ce3 եΥ쥤䡼7ȥ쥤䡼0Ĥ
#  perl layerFilter.pl  -L 81 sample.ce3[Enter]
# Ȥޤ


# ޥɥ饤β
($targetFile,$layerMask) = &parseCmdLine();

# ޥͤ0åȥե뤬.ce3ǤʤСusageåϤƽλ
if($layerMask== 0 || $targetFile !~ /\.ce3$/i){
	print "USAGE: perl layerFilter.pl  -L maskvalue CE3file[Enter]\n";
	print "   maskvalue - layers in hexadecimal\n";
	print "   CE3file   - BSch3V schematic data\n";
	exit(255);
}

printf("Target file: %s\n",$targetFile);
printf("Layer Mask:  0x%X\n",$layerMask);


$outfile = $targetFile;
$srcfile = $targetFile."\$";

#ե̾ѹƥХååפȤ
if((rename $outfile, $srcfile) == 0){
	die "Backup error.\n";
}

#եΥץ
open(IN,$srcfile) || die "ERROR open source file :$srcfile\n";
open(OUT,">".$outfile) || die "ERROR open destination file :$outfile\n";

$ce3init = 1;
$readlib = 0;
$readcomp = 0;

@LayerBitTable = (1,2,4,8,16,32,64,128);

@BSchDataElmBGN = ("+COMPONENT","+BUS","+WIRE","+DASH","+ALINE","+JUNCTION","+BENTRY","+ENTRY","+TAG","+LABEL","+COMMENT");
@BSchDataElmEND = ("-COMPONENT","-BUS","-WIRE","-DASH","-ALINE","-JUNCTION","-BENTRY","-ENTRY","-TAG","-LABEL","-COMMENT");
$BSchDataElmCNT = @BSchDataElmBGN;		# ǡǤμ

$DataElm = -1;	# Υǡ
$OutString = "";
$ValidFlag = 1;



while(1){
	($ce3rec,$getce3stus) = getCE3Record(*IN,$ce3init);
	$ce3init = 0;
	if($getce3stus == -1){
		last;
	}
	
	if($getce3stus==0){
		$delim = ",";
	}else{
		$delim = "\n";
	}
	
	if($DataElm >= 0){	# ǡǤν
		if($ce3rec eq $BSchDataElmEND[$DataElm]){	# ǡǤб뽪λΥå
			#print "Detec End TAG\n";
			$DataElm = -1;
			$readlib = 0;
		}else{
			if($DataElm == 0){	# COMPONENTΤȤϥ饤֥"L:"򥹥åפʤФʤʤ
				if($readlib == 1){
					if($ce3rec =~ /^\-BSCH3\_LIB\_V/){
						$readlib = 0;
					}
				}elsif($ce3rec =~ /^\+BSCH3\_LIB\_V/){
					$readlib = 1;
				}
			}
			if($readlib == 0 && $ce3rec =~ /^L:/){	# 쥤䡼Υå
				$layerValue = substr($ce3rec,2);	# 쥤䡼ͤμ
				if($layerValue>=0 && $layerValue<8){
					$layerBitValue = $LayerBitTable[$layerValue];	# 쥤䡼(07)ӥåͤѴ
#					printf("Read layerValue : %d  0x%X   0x%X Original data %s\n",$layerValue,$layerBitValue, $layerMask, $ce3rec);
					if(($layerBitValue & $layerMask)==0){	# ޥͤȥ쥤䡼ӥåͤAND0ʤValidFlagݤ
						$ValidFlag = 0;
					}
				}
			}
		}
		$OutString = $OutString.$ce3rec;
		$OutString = $OutString.$delim;
	}else{
		for($i=0;$i<$BSchDataElmCNT;$i++){
			if($BSchDataElmBGN[$i] eq $ce3rec){
				$DataElm = $i;
				last;
			}
		}
		$OutString = $ce3rec.$delim;
		$ValidFlag = 1;
	}

	if($DataElm == -1 && $ValidFlag == 1){
		print OUT $OutString;
	}
}

close IN;
close OUT;

exit(0);

###########################################################################
# ޥɥ饤β
sub parseCmdLine {
	my($option,$targetFile,$layerMask,$argc,$n);
	$option = 0;
	
	$targetFile = "";
	$layerMask = 0xff;

	$argc = @ARGV; 
	if($argc>0){
		for($n = 0; $n<$argc; $n++){
#			print $ARGV[$n]."\n";
			if($option == 1){
				$layerMask = hex($ARGV[$n]);
				$option = 0;
			}elsif($ARGV[$n] eq "-L"){
				$option = 1;
			}else{
				$targetFile = $ARGV[$n];
			}
		}
	}
	return ($targetFile,$layerMask);
}

	


##############################################################
# CE3ե뤫顢쥳ɤڤФ
BEGIN{
	my($line,@recarray,$reccount,$index,$retrec);
	$index = 0;		#1(index)ܤΥ쥳ɤ򤳤줫롣
	$reccount = 0;	#1Υ쥳ɤο
	sub getCE3Record {
		local(*readfile, $init) = @_;
		my($line,$retrec,$status);
		
		if($init!=0 || $index == $reccount){
			$index = 0;
		}
		
		if($index==0){
			while(1){
				if($line=<readfile>){
				    chomp($line);                   #βԤκ
					@recarray = &splitce3($line);	#뤴Ȥʬ
		    		$reccount = @recarray;
				}else{
					return("",-1);
				}
				if($reccount>0){
					last;
				}
			}
		}
		$retrec = $recarray[$index];
		$retrec =~ s/^\s*(\S+)\s*$/$1/g;			#ξüζκ
		$index = $index + 1;
		if($index == $reccount){
			$status = 1;
		}else{
			$status = 0;
		}
		return ($retrec,$status);
	}
}

###########################################################################
# CE3ԤΥץåȤԤ֥롼
sub splitce3 {
    my($ce3str) = @_;
    my(@splitdata,$recdata);
    $ce3str .= ',';  							# ԤκǸˡ,פղä
    @splitdata= split(/,/, $ce3str);			# CE3ե,ǥץåȤǤ
    return @splitdata;
}


